package com.mycompany.myapp;

import android.util.Log;
import com.mycompany.common.MyCompanyApplication;
import org.aspectj.lang.JoinPoint;

/**
 * TODO: Add description
 *
 * @author archinamon on 24/05/17.
 */
public aspect ApplicationTransformer {

    private interface ITransformable {}

    declare parents: @Transformable MyCompanyApplication+ implements ITransformable;

    private void ITransformable.transform(JoinPoint jp) {
        Log.v("AspectJ", jp.getSourceLocation().getFileName() + " has been transformed!");
    }

    pointcut declareTransform(MyCompanyApplication app): this(app) && execution(void (@Transformable MyCompanyApplication+).onCreate());

    after(MyCompanyApplication app): declareTransform(app) {
        ((ITransformable) app).transform(thisJoinPoint);
    }
}
